## qmapshack 1.18.1

=== CMakeLists.txt ===
###############################################################################################
# CMake compatibility requirements
###############################################################################################
cmake_minimum_required(VERSION 3.20.0)

# Needed to properly handle extract translations strings when using the Ninja
# generator.
if (COMMAND CMAKE_POLICY)
    if (POLICY CMP0058)
        cmake_policy(SET CMP0058 NEW)
    endif()
endif()

if (COMMAND CMAKE_POLICY)
    if (POLICY CMP0048)
        cmake_policy(SET CMP0048 NEW)
    endif()
endif()


###############################################################################################
# Define project name and version tags
###############################################################################################
# this is not only the QMS version it will be the package version, too.
project(QMapShack VERSION 1.18.1 LANGUAGES CXX C)
set(CMAKE_CXX_STANDARD 11)

# FOR A RELEASE:
# remove "development" for a release
set(DEVELOPMENT_VERSION OFF)


###############################################################################################
# Define paths and include other modules
###############################################################################################
# where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/ is checked
if(WIN32)
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/Modules;${CMAKE_SOURCE_DIR}/msvc_64/cmake)
else(WIN32)
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/Modules)
endif(WIN32)

# all binaries are collected in the ./bin directory
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin)

include(DefineCMakeDefaults)
include(DefineCompilerFlags)
include(DefineInstallationPaths)
include(CPackConfig.cmake)
include(ConfigureChecks.cmake)

###############################################################################################
# All boolean options
###############################################################################################

# Feature related
option(BUILD_QMAPSHACK      "Build QMapShack Binary"                                ON)
option(BUILD_QMAPTOOL       "Build QMapTool Binary including command line tools"    ON)

if(WIN32)
option(USE_QT6DBus          "Enable device detection via DBus"                      OFF)
else(WIN32)
option(USE_QT6DBus          "Enable device detection via DBus"                      ON)
endif(WIN32)

# Compiler related
option(BUILD_FOR_LOCAL_SYSTEM "Build for local system ONLY (resulting binary might not work on other systems!)" OFF)

###############################################################################################
# Translation options
###############################################################################################
option(UPDATE_TRANSLATIONS "Update translation files" OFF)
option(UPDATE_TRANSLATIONS_PURGE_OBSOLETE "Remove obsolete translations" OFF)


###############################################################################################
# All OS and compiler specific tweaks
###############################################################################################
if (APPLE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS_INIT} -Wall -std=c++11 -stdlib=libc++")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -stdlib=libc++")
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -framework Foundation -framework DiskArbitration")
    SET(LINK_FLAGS "${LINK_FLAGS} -framework Foundation -framework DiskArbitration")

    if(NOT DEFINED QT_DEV_PATH)
        message(FATAL_ERROR "QT_DEV_PATH not set!!!")
    endif()
    # set(QT_DEV_PATH   ${QT_DEV_PATH} CACHE PATH "Path to directory containing Qt6 include and lib")
    message("QT_DEV_PATH = ${QT_DEV_PATH}")

    if(NOT DEFINED ROUTINO_DEV_PATH)
        message(FATAL_ERROR "ROUTINO_DEV_PATH not set!!!")
    endif(NOT DEFINED ROUTINO_DEV_PATH)
    # set(ROUTINO_DEV_PATH ${ROUTINO_DEV_PATH} CACHE PATH "Path to directory containing routino include and lib")
    message("ROUTINO_DEV_PATH = ${ROUTINO_DEV_PATH}")
    
    if(NOT DEFINED QuaZip-Qt6_DIR)
        message(FATAL_ERROR "QuaZip-Qt6_DIR not set!!!")
    endif(NOT DEFINED QuaZip-Qt6_DIR)    
    # set(QuaZip-Qt6_DIR ${QuaZip-Qt6_DIR} CACHE PATH "Path to directory containing quazip cmake config files")
    message("QuaZip-Qt6_DIR = ${QuaZip-Qt6_DIR}")

    if(NOT DEFINED PROJ_DEV_PATH)
        message(FATAL_ERROR "PROJ_DEV_PATH not set!!!")
    endif(NOT DEFINED PROJ_DEV_PATH)
    # set(PROJ_DEV_PATH ${PROJ_DEV_PATH} CACHE PATH "Path to directory containing PROJ include and lib")
    message("PROJ_DEV_PATH = ${PROJ_DEV_PATH}")

    if(NOT DEFINED GDAL_DEV_PATH)
        message(FATAL_ERROR "GDAL_DEV_PATH not set!!!")
    endif(NOT DEFINED GDAL_DEV_PATH)
    # set(GDAL_DEV_PATH ${GDAL_DEV_PATH} CACHE PATH "Path to directory containing GDAL include and lib")
    message("GDAL_DEV_PATH = ${GDAL_DEV_PATH}")
    # set(JPEG_DEV_PATH "C:\\JPEG" CACHE PATH "Path to directory containing JPEG include and lib, e.g. M:\\lib\\JPEG")

    set(CMAKE_PREFIX_PATH ${QT_DEV_PATH})
    message("CMAKE_PREFIX_PATH = ${CMAKE_PREFIX_PATH}")
endif(APPLE)

if(WIN32)
    set(QT_DEV_PATH   "C:\\Qt\\5.12.11\\msvc2017_64" CACHE PATH "Path to directory containing Qt6 include and lib, e.g. C:\\Qt\\5.12.10\\msvc2017_64")
    set(GDAL_DEV_PATH "C:\\GDAL" CACHE PATH "Path to directory containing GDAL include and lib, e.g. M:\\lib\\gdal")
    set(PROJ_DEV_PATH "C:\\PROJ8" CACHE PATH "Path to directory containing PROJ include and lib, e.g. M:\\lib\\PROJ8")
    set(ROUTINO_DEV_PATH "C:\\routino" CACHE PATH "Path to directory containing routino include and lib, e.g. M:\\lib\\routino")
    set(QuaZip-Qt6_DIR "C:\\quazip" CACHE PATH "Path to directory containing quazip cmake config files, e.g. M:\\lib2017\\QUAZIP_1\\lib\\cmake\\QuaZip-Qt5-1.1")
    set(JPEG_DEV_PATH "C:\\JPEG" CACHE PATH "Path to directory containing JPEG include and lib, e.g. M:\\lib\\JPEG")
    set(CMAKE_PREFIX_PATH ${QT_DEV_PATH})
    if(POLICY CMP0074)
        #policy for <PackageName>_ROOT variables - see https://cmake.org/cmake/help/latest/policy/CMP0074.html
        cmake_policy(SET CMP0074 NEW)
    endif()	
    set(ZLIB_ROOT "C:\\zlib" CACHE PATH "Path to directory containing ZLIB, e.g. M:\\lib2017\\zlib")
    set(ZLIB_LIBRARY "C:\\zlib\\lib\\zlibwapi.lib" CACHE FILEPATH "Path to directory containing ZLIB library, e.g. M:\\lib2017\\zlib\\lib\\zlibwapi.lib")
endif(WIN32)

if(MSVC)
    # Add link-time code generation to improve performance
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /GL")
    set(CMAKE_EXE_LINKER_FLAGS_RELEASE    "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /LTCG")
    set(CMAKE_MODULE_LINKER_FLAGS_RELEASE "${CMAKE_MODULE_LINKER_FLAGS_RELEASE} /LTCG")
    set(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} /LTCG")
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    add_compile_options(/MP)
endif(MSVC)

if(UNIX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -lm")
    add_definitions(-Wall -Wpedantic -Wno-switch -Wno-strict-aliasing)

    # Use ASAN for development versions
    if(${DEVELOPMENT_VERSION})
        check_cxx_compiler_flag("-fsanitize=address" WITH_ASAN)
        if(NOT ${WITH_ASAN})
            message(FATAL_ERROR "Could not find ASAN! Please install ASAN if you want to compile development versions." )
        endif(NOT ${WITH_ASAN})
        message(STATUS "Using ASAN")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fno-omit-frame-pointer")
    endif(${DEVELOPMENT_VERSION})
endif(UNIX)


###############################################################################################
# GCC specific compiler tweaks
###############################################################################################
if(BUILD_FOR_LOCAL_SYSTEM)
    cxx_local_system_optimization()
endif(BUILD_FOR_LOCAL_SYSTEM)

# try to figure out which compiler flags are supported (and add them)
cxx_add_flag_if_supported(-Wsuggest-override)
cxx_add_flag_if_supported(-Woverloaded-virtual)

###############################################################################################
# Find all required packages and setup internal variables
###############################################################################################
find_package(Qt6Core                REQUIRED)


if (Qt6Core_VERSION VERSION_LESS 6.8.0)
        message(FATAL_ERROR "Qt 6.8.0 or later is required.")
endif()


find_package(Qt6Widgets             REQUIRED)
find_package(Qt6Xml                 REQUIRED)
find_package(Qt6Sql                 REQUIRED)
find_package(Qt6LinguistTools       REQUIRED)
find_package(Qt6PrintSupport        REQUIRED)
find_package(Qt6UiTools             REQUIRED)
find_package(Qt6Network             REQUIRED)
find_package(Qt6WebEngineWidgets    REQUIRED)
find_package(Qt6Qml                 REQUIRED)
find_package(Qt6Help                REQUIRED)
find_package(GDAL                   REQUIRED)
find_package(PROJ                   REQUIRED)
find_package(JPEG                   REQUIRED)
find_package(ROUTINO                REQUIRED)
find_package(QuaZip-Qt6             REQUIRED)
find_package(ALGLIB                         ) # optional as we can use our local version

qt_standard_project_setup(
    I18N_TRANSLATED_LANGUAGES ca cs de es fr it nl ru
)

if(${PROJ_VERSION} VERSION_LESS 8.0.0)
    message( SEND_ERROR "You need at least PROJ 8.0.0 or newer.")
endif()

if(USE_QT6DBus)
    find_package(Qt6DBus REQUIRED)
    if(Qt6DBus_FOUND)
        add_definitions(-DHAVE_DBUS)
    endif(Qt6DBus_FOUND)
endif(USE_QT6DBus)

# Everything included. Let's finetune the mess a bit more

if(APPLE)
     find_library(DiskArbitration_LIBRARY DiskArbitration)
     find_library(Foundation_LIBRARY Foundation)
endif(APPLE)


if(NOT ALGLIB_FOUND AND BUILD_QMAPSHACK)
    set(ALGLIB_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/alglib/src)
    set(ALGLIB_LIBRARIES alg)
    add_subdirectory(3rdparty/alglib)
endif(NOT ALGLIB_FOUND AND BUILD_QMAPSHACK)

add_definitions(-DHELPPATH=${HTML_INSTALL_DIR})

###############################################################################################
# Create library from Garmin's FIT SDK
###############################################################################################
add_subdirectory(3rdparty/GarminFitSdk/)

###############################################################################################
# Create global config.h
###############################################################################################
if (APPLE)
  set(PROGNAME "QMapShack")
  set(CONFIGDIR "Library/Application Support/${PROGNAME}/")
else(APPLE)
  set(PROGNAME ${PROJECT_NAME})
  set(CONFIGDIR ".config/QLandkarte/")
endif(APPLE)

configure_file(config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

###############################################################################################
# Now we are ready to compile all sub-projects
###############################################################################################
if(BUILD_QMAPSHACK)
add_subdirectory(src/qmapshack)
endif(BUILD_QMAPSHACK)

if(BUILD_QMAPTOOL)
add_subdirectory(src/qmaptool)
add_subdirectory(src/qmt_rgb2pct)
add_subdirectory(src/qmt_map2jnx)
endif(BUILD_QMAPTOOL)

###############################################################################################
# Copy a few more files need by the install/unistall target
###############################################################################################
if (UNIX AND NOT WIN32 AND NOT APPLE)
if(BUILD_QMAPSHACK)
    install( FILES        qmapshack.desktop                 DESTINATION     ${XDG_APPS_DIR} )
    install( FILES        src/icons/48x48/QMapShack.png     DESTINATION     ${DATA_INSTALL_PREFIX}/pixmaps )
    install( DIRECTORY    src/icons/qmapshack/hicolor       DESTINATION     ${ICON_INSTALL_DIR} )
    install( FILES        qmapshack.1                       DESTINATION     ${MAN_INSTALL_DIR}/man1  )

=== cmake/CMakeLists.txt ===
add_subdirectory(Modules)

=== 3rdparty/GarminFitSdk/CMakeLists.txt ===

set(FIT_SRC
    cpp/fit_accumulated_field.cpp
    cpp/fit_accumulator.cpp
    cpp/fit_buffered_mesg_broadcaster.cpp
    cpp/fit_buffered_record_mesg_broadcaster.cpp
    cpp/fit_buffer_encode.cpp
    cpp/fit.cpp
    cpp/fit_crc.cpp
    cpp/fit_date_time.cpp
    cpp/fit_decode.cpp
    cpp/fit_developer_field.cpp
    cpp/fit_developer_field_definition.cpp
    cpp/fit_developer_field_description.cpp
    cpp/fit_encode.cpp
    cpp/fit_factory.cpp
    cpp/fit_field_base.cpp
    cpp/fit_field.cpp
    cpp/fit_field_definition.cpp
    cpp/fit_mesg_broadcaster.cpp
    cpp/fit_mesg.cpp
    cpp/fit_mesg_definition.cpp
    cpp/fit_mesg_with_event_broadcaster.cpp
    cpp/fit_profile.cpp
    cpp/fit_protocol_validator.cpp
    cpp/fit_unicode.cpp
)

set(FIT_HDR 
    cpp/fit_aad_accel_features_mesg.hpp
    cpp/fit_aad_accel_features_mesg_listener.hpp
    cpp/fit_accelerometer_data_mesg.hpp
    cpp/fit_accelerometer_data_mesg_listener.hpp
    cpp/fit_accumulated_field.hpp
    cpp/fit_accumulator.hpp
    cpp/fit_activity_mesg.hpp
    cpp/fit_activity_mesg_listener.hpp
    cpp/fit_ant_channel_id_mesg.hpp
    cpp/fit_ant_channel_id_mesg_listener.hpp
    cpp/fit_ant_rx_mesg.hpp
    cpp/fit_ant_rx_mesg_listener.hpp
    cpp/fit_ant_tx_mesg.hpp
    cpp/fit_ant_tx_mesg_listener.hpp
    cpp/fit_aviation_attitude_mesg.hpp
    cpp/fit_aviation_attitude_mesg_listener.hpp
    cpp/fit_barometer_data_mesg.hpp
    cpp/fit_barometer_data_mesg_listener.hpp
    cpp/fit_beat_intervals_mesg.hpp
    cpp/fit_beat_intervals_mesg_listener.hpp
    cpp/fit_bike_profile_mesg.hpp
    cpp/fit_bike_profile_mesg_listener.hpp
    cpp/fit_blood_pressure_mesg.hpp
    cpp/fit_blood_pressure_mesg_listener.hpp
    cpp/fit_buffered_mesg_broadcaster.hpp
    cpp/fit_buffered_record_mesg_broadcaster.hpp
    cpp/fit_buffered_record_mesg.hpp
    cpp/fit_buffered_record_mesg_listener.hpp
    cpp/fit_buffer_encode.hpp
    cpp/fit_cadence_zone_mesg.hpp
    cpp/fit_cadence_zone_mesg_listener.hpp
    cpp/fit_camera_event_mesg.hpp
    cpp/fit_camera_event_mesg_listener.hpp
    cpp/fit_capabilities_mesg.hpp
    cpp/fit_capabilities_mesg_listener.hpp
    cpp/fit_chrono_shot_data_mesg.hpp
    cpp/fit_chrono_shot_data_mesg_listener.hpp
    cpp/fit_chrono_shot_session_mesg.hpp
    cpp/fit_chrono_shot_session_mesg_listener.hpp
    cpp/fit_climb_pro_mesg.hpp
    cpp/fit_climb_pro_mesg_listener.hpp
    cpp/fit_config.hpp
    cpp/fit_connectivity_mesg.hpp
    cpp/fit_connectivity_mesg_listener.hpp
    cpp/fit_course_mesg.hpp
    cpp/fit_course_mesg_listener.hpp
    cpp/fit_course_point_mesg.hpp
    cpp/fit_course_point_mesg_listener.hpp
    cpp/fit_crc.hpp
    cpp/fit_date_time.hpp
    cpp/fit_decode.hpp
    cpp/fit_developer_data_id_mesg.hpp
    cpp/fit_developer_data_id_mesg_listener.hpp
    cpp/fit_developer_field_definition.hpp
    cpp/fit_developer_field_description.hpp
    cpp/fit_developer_field_description_listener.hpp
    cpp/fit_developer_field.hpp
    cpp/fit_device_aux_battery_info_mesg.hpp
    cpp/fit_device_aux_battery_info_mesg_listener.hpp
    cpp/fit_device_info_mesg.hpp
    cpp/fit_device_info_mesg_listener.hpp
    cpp/fit_device_settings_mesg.hpp
    cpp/fit_device_settings_mesg_listener.hpp
    cpp/fit_dive_alarm_mesg.hpp
    cpp/fit_dive_alarm_mesg_listener.hpp
    cpp/fit_dive_apnea_alarm_mesg.hpp
    cpp/fit_dive_apnea_alarm_mesg_listener.hpp
    cpp/fit_dive_gas_mesg.hpp
    cpp/fit_dive_gas_mesg_listener.hpp
    cpp/fit_dive_settings_mesg.hpp
    cpp/fit_dive_settings_mesg_listener.hpp
    cpp/fit_dive_summary_mesg.hpp
    cpp/fit_dive_summary_mesg_listener.hpp
    cpp/fit_encode.hpp
    cpp/fit_event_mesg.hpp
    cpp/fit_event_mesg_listener.hpp
    cpp/fit_exd_data_concept_configuration_mesg.hpp
    cpp/fit_exd_data_concept_configuration_mesg_listener.hpp
    cpp/fit_exd_data_field_configuration_mesg.hpp
    cpp/fit_exd_data_field_configuration_mesg_listener.hpp
    cpp/fit_exd_screen_configuration_mesg.hpp
    cpp/fit_exd_screen_configuration_mesg_listener.hpp
    cpp/fit_exercise_title_mesg.hpp
    cpp/fit_exercise_title_mesg_listener.hpp
    cpp/fit_factory.hpp
    cpp/fit_field_base.hpp
    cpp/fit_field_capabilities_mesg.hpp
    cpp/fit_field_capabilities_mesg_listener.hpp
    cpp/fit_field_definition.hpp
    cpp/fit_field_description_mesg.hpp
    cpp/fit_field_description_mesg_listener.hpp
    cpp/fit_field.hpp
    cpp/fit_file_capabilities_mesg.hpp
    cpp/fit_file_capabilities_mesg_listener.hpp
    cpp/fit_file_creator_mesg.hpp
    cpp/fit_file_creator_mesg_listener.hpp
    cpp/fit_file_id_mesg.hpp
    cpp/fit_file_id_mesg_listener.hpp
    cpp/fit_goal_mesg.hpp
    cpp/fit_goal_mesg_listener.hpp
    cpp/fit_gps_metadata_mesg.hpp
    cpp/fit_gps_metadata_mesg_listener.hpp
    cpp/fit_gyroscope_data_mesg.hpp
    cpp/fit_gyroscope_data_mesg_listener.hpp
    cpp/fit.hpp
    cpp/fit_hr_mesg.hpp
    cpp/fit_hr_mesg_listener.hpp
    cpp/fit_hrm_profile_mesg.hpp
    cpp/fit_hrm_profile_mesg_listener.hpp
    cpp/fit_hrv_mesg.hpp
    cpp/fit_hrv_mesg_listener.hpp
    cpp/fit_hrv_status_summary_mesg.hpp
    cpp/fit_hrv_status_summary_mesg_listener.hpp
    cpp/fit_hrv_value_mesg.hpp
    cpp/fit_hrv_value_mesg_listener.hpp
    cpp/fit_hr_zone_mesg.hpp
    cpp/fit_hr_zone_mesg_listener.hpp
    cpp/fit_hsa_accelerometer_data_mesg.hpp
    cpp/fit_hsa_accelerometer_data_mesg_listener.hpp
    cpp/fit_hsa_body_battery_data_mesg.hpp
    cpp/fit_hsa_body_battery_data_mesg_listener.hpp
    cpp/fit_hsa_configuration_data_mesg.hpp
    cpp/fit_hsa_configuration_data_mesg_listener.hpp
    cpp/fit_hsa_event_mesg.hpp
    cpp/fit_hsa_event_mesg_listener.hpp
    cpp/fit_hsa_gyroscope_data_mesg.hpp
    cpp/fit_hsa_gyroscope_data_mesg_listener.hpp
    cpp/fit_hsa_heart_rate_data_mesg.hpp
    cpp/fit_hsa_heart_rate_data_mesg_listener.hpp
    cpp/fit_hsa_respiration_data_mesg.hpp
    cpp/fit_hsa_respiration_data_mesg_listener.hpp
    cpp/fit_hsa_spo2_data_mesg.hpp
    cpp/fit_hsa_spo2_data_mesg_listener.hpp
    cpp/fit_hsa_step_data_mesg.hpp
    cpp/fit_hsa_step_data_mesg_listener.hpp
    cpp/fit_hsa_stress_data_mesg.hpp
    cpp/fit_hsa_stress_data_mesg_listener.hpp
    cpp/fit_hsa_wrist_temperature_data_mesg.hpp
    cpp/fit_hsa_wrist_temperature_data_mesg_listener.hpp
    cpp/fit_jump_mesg.hpp
    cpp/fit_jump_mesg_listener.hpp
    cpp/fit_lap_mesg.hpp
    cpp/fit_lap_mesg_listener.hpp
    cpp/fit_length_mesg.hpp
    cpp/fit_length_mesg_listener.hpp
    cpp/fit_magnetometer_data_mesg.hpp
    cpp/fit_magnetometer_data_mesg_listener.hpp
    cpp/fit_max_met_data_mesg.hpp
    cpp/fit_max_met_data_mesg_listener.hpp
    cpp/fit_memo_glob_mesg.hpp
    cpp/fit_memo_glob_mesg_listener.hpp
    cpp/fit_mesg_broadcaster.hpp
    cpp/fit_mesg_broadcast_plugin.hpp
    cpp/fit_mesg_capabilities_mesg.hpp
    cpp/fit_mesg_capabilities_mesg_listener.hpp
    cpp/fit_mesg_definition.hpp
    cpp/fit_mesg_definition_listener.hpp
    cpp/fit_mesg.hpp
    cpp/fit_mesg_listener.hpp
    cpp/fit_mesg_with_event_broadcaster.hpp
    cpp/fit_mesg_with_event.hpp
    cpp/fit_mesg_with_event_listener.hpp
    cpp/fit_met_zone_mesg.hpp
    cpp/fit_met_zone_mesg_listener.hpp
    cpp/fit_monitoring_hr_data_mesg.hpp
    cpp/fit_monitoring_hr_data_mesg_listener.hpp
    cpp/fit_monitoring_info_mesg.hpp
    cpp/fit_monitoring_info_mesg_listener.hpp
    cpp/fit_monitoring_mesg.hpp
    cpp/fit_monitoring_mesg_listener.hpp
    cpp/fit_nmea_sentence_mesg.hpp
    cpp/fit_nmea_sentence_mesg_listener.hpp
    cpp/fit_obdii_data_mesg.hpp
    cpp/fit_obdii_data_mesg_listener.hpp
    cpp/fit_ohr_settings_mesg.hpp
    cpp/fit_ohr_settings_mesg_listener.hpp
    cpp/fit_one_d_sensor_calibration_mesg.hpp
    cpp/fit_one_d_sensor_calibration_mesg_listener.hpp
    cpp/fit_pad_mesg.hpp
    cpp/fit_pad_mesg_listener.hpp
    cpp/fit_power_zone_mesg.hpp
    cpp/fit_power_zone_mesg_listener.hpp
    cpp/fit_profile.hpp
    cpp/fit_protocol_validator.hpp
    cpp/fit_raw_bbi_mesg.hpp
    cpp/fit_raw_bbi_mesg_listener.hpp
    cpp/fit_record_mesg.hpp
    cpp/fit_record_mesg_listener.hpp
    cpp/fit_respiration_rate_mesg.hpp
    cpp/fit_respiration_rate_mesg_listener.hpp
    cpp/fit_runtime_exception.hpp
    cpp/fit_schedule_mesg.hpp
    cpp/fit_schedule_mesg_listener.hpp
    cpp/fit_sdm_profile_mesg.hpp
    cpp/fit_sdm_profile_mesg_listener.hpp
    cpp/fit_segment_file_mesg.hpp
    cpp/fit_segment_file_mesg_listener.hpp
    cpp/fit_segment_id_mesg.hpp
    cpp/fit_segment_id_mesg_listener.hpp
    cpp/fit_segment_lap_mesg.hpp
    cpp/fit_segment_lap_mesg_listener.hpp
    cpp/fit_segment_leaderboard_entry_mesg.hpp
    cpp/fit_segment_leaderboard_entry_mesg_listener.hpp
    cpp/fit_segment_point_mesg.hpp
    cpp/fit_segment_point_mesg_listener.hpp
    cpp/fit_session_mesg.hpp
    cpp/fit_session_mesg_listener.hpp
    cpp/fit_set_mesg.hpp
    cpp/fit_set_mesg_listener.hpp
    cpp/fit_skin_temp_overnight_mesg.hpp
    cpp/fit_skin_temp_overnight_mesg_listener.hpp
    cpp/fit_slave_device_mesg.hpp
    cpp/fit_slave_device_mesg_listener.hpp
    cpp/fit_sleep_assessment_mesg.hpp
    cpp/fit_sleep_assessment_mesg_listener.hpp
    cpp/fit_sleep_level_mesg.hpp
    cpp/fit_sleep_level_mesg_listener.hpp
    cpp/fit_software_mesg.hpp
    cpp/fit_software_mesg_listener.hpp
    cpp/fit_speed_zone_mesg.hpp
    cpp/fit_speed_zone_mesg_listener.hpp
    cpp/fit_split_mesg.hpp
    cpp/fit_split_mesg_listener.hpp
    cpp/fit_split_summary_mesg.hpp
    cpp/fit_split_summary_mesg_listener.hpp
    cpp/fit_spo2_data_mesg.hpp
    cpp/fit_spo2_data_mesg_listener.hpp
    cpp/fit_sport_mesg.hpp
    cpp/fit_sport_mesg_listener.hpp
    cpp/fit_stress_level_mesg.hpp
    cpp/fit_stress_level_mesg_listener.hpp
    cpp/fit_tank_summary_mesg.hpp
    cpp/fit_tank_summary_mesg_listener.hpp
    cpp/fit_tank_update_mesg.hpp
    cpp/fit_tank_update_mesg_listener.hpp
    cpp/fit_three_d_sensor_calibration_mesg.hpp
    cpp/fit_three_d_sensor_calibration_mesg_listener.hpp
    cpp/fit_time_in_zone_mesg.hpp
    cpp/fit_time_in_zone_mesg_listener.hpp
    cpp/fit_timestamp_correlation_mesg.hpp
    cpp/fit_timestamp_correlation_mesg_listener.hpp
    cpp/fit_totals_mesg.hpp
    cpp/fit_totals_mesg_listener.hpp
    cpp/fit_training_file_mesg.hpp
    cpp/fit_training_file_mesg_listener.hpp
    cpp/fit_unicode.hpp
    cpp/fit_user_profile_mesg.hpp
    cpp/fit_user_profile_mesg_listener.hpp
    cpp/fit_video_clip_mesg.hpp
    cpp/fit_video_clip_mesg_listener.hpp
    cpp/fit_video_description_mesg.hpp
    cpp/fit_video_description_mesg_listener.hpp
    cpp/fit_video_frame_mesg.hpp
    cpp/fit_video_frame_mesg_listener.hpp
    cpp/fit_video_mesg.hpp
    cpp/fit_video_mesg_listener.hpp
    cpp/fit_video_title_mesg.hpp
    cpp/fit_video_title_mesg_listener.hpp
    cpp/fit_watchface_settings_mesg.hpp
    cpp/fit_watchface_settings_mesg_listener.hpp
    cpp/fit_weather_alert_mesg.hpp
    cpp/fit_weather_alert_mesg_listener.hpp
    cpp/fit_weather_conditions_mesg.hpp
    cpp/fit_weather_conditions_mesg_listener.hpp
    cpp/fit_weight_scale_mesg.hpp
    cpp/fit_weight_scale_mesg_listener.hpp
    cpp/fit_workout_mesg.hpp
    cpp/fit_workout_mesg_listener.hpp
    cpp/fit_workout_session_mesg.hpp
    cpp/fit_workout_session_mesg_listener.hpp
    cpp/fit_workout_step_mesg.hpp
    cpp/fit_workout_step_mesg_listener.hpp
    cpp/fit_zones_target_mesg.hpp
    cpp/fit_zones_target_mesg_listener.hpp  
)

add_library(GarminFit STATIC ${FIT_SRC} ${FIT_HDR})
# Geeee, this code is so sloppy written. Let's silence the warnings.
if(UNIX)
    target_compile_options(GarminFit PRIVATE -Wno-suggest-override -Wno-catch-value -Wno-unused-but-set-variable)
endif()

# add_executable(fit_decoder cpp/examples/decode/decode.cpp )
# target_link_libraries(fit_decoder PRIVATE GarminFit)
# target_include_directories(fit_decoder PRIVATE cpp)

=== cmake/Modules/CMakeLists.txt ===
# install the cmake files

file(GLOB cmakeFiles "${CMAKE_CURRENT_SOURCE_DIR}/*.cmake")

set(module_install_dir ${DATA_INSTALL_DIR}/cmake/modules )

install(
  FILES
    ${cmakeFiles}
  DESTINATION
  ${module_install_dir}
)
# the files listed here will be removed by remove_obsoleted_cmake_files.cmake, Alex
set(FILES_TO_REMOVE
)

install(SCRIPT ${CMAKE_CURRENT_BINARY_DIR}/remove_files.cmake )

file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/remove_files.cmake "#generated by cmake, don't edit\n\n")
foreach ( _current_FILE ${FILES_TO_REMOVE})
   file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/remove_files.cmake "message(STATUS \"Removing ${module_install_dir}/${_current_FILE}\" )\n" )
   file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/remove_files.cmake "exec_program( ${CMAKE_COMMAND} ARGS -E remove ${module_install_dir}/${_current_FILE} OUTPUT_VARIABLE _dummy)\n" )
endforeach ( _current_FILE)

=== src/qmapshack/CMakeLists.txt ===
# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)
# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)


###############################################################################################
# Setup application name and defines
###############################################################################################

STRING(TOLOWER ${PROJECT_NAME} APPLICATION_NAME)

# and other funny defines -> maybe config.h is a better place for that
add_definitions(-DROUTINO_XML_PATH=${ROUTINO_XML_PATH})

###############################################################################################
# All source files needed to compile
###############################################################################################

set( SRCS
    CAbout.cpp
    CMainWindow.cpp
    CSingleInstanceProxy.cpp
    canvas/CCanvas.cpp
    canvas/CCanvasSetup.cpp
    canvas/CCanvasSelect.cpp
    canvas/IDrawContext.cpp
    canvas/IDrawObject.cpp
    dem/CDemDraw.cpp
    dem/CDemItem.cpp
    dem/CDemList.cpp
    dem/CDemPathSetup.cpp
    dem/CDemPropSetup.cpp
    dem/CDemVRT.cpp
    dem/CDemWCS.cpp
    dem/IDem.cpp
    dem/IDemProp.cpp
    device/CDeviceGarmin.cpp
    device/CDeviceGarminArchive.cpp
    device/CDeviceTwoNav.cpp
    device/IDevice.cpp
    device/IDeviceWatcher.cpp
    gis/CGisDatabase.cpp
    gis/CGisDraw.cpp
    gis/CGisItemRate.cpp
    gis/CGisListDB.cpp
    gis/CGisListWks.cpp
    gis/CGisWorkspace.cpp
    gis/CSelDevices.cpp
    gis/IGisItem.cpp
    gis/IGisLine.cpp
    gis/db/CDBFolderGroup.cpp
    gis/db/CDBFolderLostFound.cpp
    gis/db/CDBFolderMysql.cpp
    gis/db/CDBFolderOther.cpp
    gis/db/CDBFolderProject.cpp
    gis/db/CDBFolderSqlite.cpp
    gis/db/CDBItem.cpp
    gis/db/CDBProject.cpp
    gis/db/CExportDatabase.cpp
    gis/db/CExportDatabaseThread.cpp
    gis/db/CLostFoundProject.cpp
    gis/db/CResolveDatabaseConflict.cpp
    gis/db/CSearchDatabase.cpp
    gis/db/CSelectDBFolder.cpp
    gis/db/CSelectSaveAction.cpp
    gis/db/CSetupDatabase.cpp
    gis/db/CSetupFolder.cpp
    gis/db/CSetupWorkspace.cpp
    gis/db/IDB.cpp
    gis/db/IDBFolder.cpp
    gis/db/IDBFolderSql.cpp
    gis/db/IDBMysql.cpp
    gis/db/IDBSqlite.cpp
    gis/fit2/CFit2Project.cpp
    gis/gpx/CGpxProject.cpp
    gis/gpx/serialization.cpp
    gis/ovl/CDetailsOvlArea.cpp
    gis/ovl/CGisItemOvlArea.cpp
    gis/ovl/CScrOptOvlArea.cpp
    gis/prj/CDetailsPrj.cpp
    gis/prj/IGisProject.cpp
    gis/qlb/CQlbProject.cpp
    gis/qms/CQmsProject.cpp
    gis/qms/serialization.cpp
    gis/rte/CCreateRouteFromWpt.cpp
    gis/rte/CDetailsRte.cpp
    gis/rte/CGisItemRte.cpp
    gis/rte/CScrOptRte.cpp
    gis/rte/router/CRouterBRouter.cpp
    gis/rte/router/CRouterOptimization.cpp
    gis/rte/router/CRouterRoutino.cpp
    gis/rte/router/CRouterSetup.cpp
    gis/rte/router/IRouter.cpp
    gis/rte/router/brouter/CRouterBRouterDownloadPage.cpp
    gis/rte/router/brouter/CRouterBRouterInfo.cpp
    gis/rte/router/brouter/CRouterBRouterLocal.cpp
    gis/rte/router/brouter/CRouterBRouterSetup.cpp
    gis/rte/router/brouter/CRouterBRouterSetupPage.cpp
    gis/rte/router/brouter/CRouterBRouterSetupWizard.cpp
    gis/rte/router/brouter/CRouterBRouterTilesPage.cpp
    gis/rte/router/brouter/CRouterBRouterTilesSelect.cpp
    gis/rte/router/brouter/CRouterBRouterTilesSelectArea.cpp
    gis/rte/router/brouter/CRouterBRouterToolShell.cpp
    gis/rte/router/routino/CRouterRoutinoPathSetup.cpp
    gis/search/CGeoSearch.cpp
    gis/search/CGeoSearchConfig.cpp
    gis/search/CGeoSearchConfigDialog.cpp
    gis/search/CProjectFilterItem.cpp
    gis/search/CSearchExplanationDialog.cpp
    gis/search/CSearchLineEdit.cpp
    gis/search/CGeoSearchWeb.cpp
    gis/search/CGeoSearchWebConfigDialog.cpp
    gis/slf/CSlfProject.cpp
    gis/slf/CSlfReader.cpp
    gis/summary/CGisSummary.cpp
    gis/summary/CGisSummaryDropZone.cpp
    gis/summary/CGisSummarySetup.cpp
    gis/suunto/CLogProject.cpp
    gis/suunto/CSmlProject.cpp
    gis/suunto/ISuuntoProject.cpp
    gis/tcx/CTcxProject.cpp
    gis/tcx/serialization.cpp
    gis/tnv/CTwoNavProject.cpp
    gis/tnv/serialization.cpp
    gis/trk/CActivityTrk.cpp
    gis/trk/CCombineTrk.cpp
    gis/trk/CCutTrk.cpp
    gis/trk/CDetailsTrk.cpp
    gis/trk/CEnergyCycling.cpp
    gis/trk/CEnergyCyclingDialog.cpp
    gis/trk/CGisItemTrk.cpp
    gis/trk/CInvalidTrk.cpp
    gis/trk/CKnownExtension.cpp
    gis/trk/CListTrkPts.cpp
    gis/trk/CPropertyTrk.cpp
    gis/trk/CScrOptTrk.cpp
    gis/trk/CSelectActivityColor.cpp
    gis/trk/CTableTrk.cpp
    gis/trk/CTableTrkInfo.cpp
    gis/trk/CTrkToRteDialog.cpp
    gis/trk/CTrackData.cpp
    gis/trk/filter/CFilterChangeStartPoint.cpp
    gis/trk/filter/CFilterDelete.cpp
    gis/trk/filter/CFilterDeleteExtension.cpp
    gis/trk/filter/CFilterDouglasPeuker.cpp
    gis/trk/filter/CFilterInterpolateElevation.cpp
    gis/trk/filter/CFilterInvalid.cpp
    gis/trk/filter/CFilterLoopsCut.cpp
    gis/trk/filter/CFilterMedian.cpp
    gis/trk/filter/CFilterNewDate.cpp
    gis/trk/filter/CFilterObscureDate.cpp
    gis/trk/filter/CFilterOffsetElevation.cpp
    gis/trk/filter/CFilterReplaceElevation.cpp
    gis/trk/filter/CFilterReset.cpp
    gis/trk/filter/CFilterSpeed.cpp
    gis/trk/filter/CFilterSpeedConst.cpp
    gis/trk/filter/CFilterSpeedCycle.cpp
    gis/trk/filter/CFilterSpeedHike.cpp
    gis/trk/filter/CFilterSplitSegment.cpp
    gis/trk/filter/CFilterSplitTrack.cpp
    gis/trk/filter/CFilterSubPt2Pt.cpp
    gis/trk/filter/CFilterTerrainSlope.cpp
    gis/trk/filter/CFilterZeroSpeedDriftCleaner.cpp
    gis/trk/filter/filter.cpp
    gis/wpt/CDetailsGeoCache.cpp
    gis/wpt/CDetailsWpt.cpp
    gis/wpt/CGisItemWpt.cpp
    gis/wpt/CProjWpt.cpp
    gis/wpt/CScrOptWpt.cpp
    gis/wpt/CScrOptWptRadius.cpp
    gis/wpt/CSetupIconAndName.cpp
    grid/CGrid.cpp
    grid/CGridSetup.cpp
    grid/CProjWizard.cpp
    grid/mitab.cpp
    helpers/CDraw.cpp
    helpers/CElevationDialog.cpp
    gis/search/CSearch.cpp
    helpers/CInputDialog.cpp
    helpers/CLimit.cpp
    helpers/CLinksDialog.cpp
    helpers/CMapIconSizesSetup.cpp
    helpers/CPhotoViewer.cpp
    helpers/CPositionDialog.cpp
    helpers/CProgressDialog.cpp
    helpers/CSelectCopyAction.cpp
    helpers/CSelectProjectDialog.cpp
    helpers/CTimeDialog.cpp
    helpers/CToolBarConfig.cpp
    helpers/CToolBarSetupDialog.cpp
    helpers/CValue.cpp
    helpers/CWptIconDialog.cpp
    helpers/CWptIconManager.cpp
    main.cpp
    map/CMapDraw.cpp
    map/CMapGEMF.cpp
    map/CMapIMG.cpp
    map/CMapItem.cpp
    map/CMapJNX.cpp
    map/CMapList.cpp
    map/CMapMAP.cpp
    map/CMapPathSetup.cpp
    map/CMapPropSetup.cpp
    map/CMapRMAP.cpp
    map/CMapTMS.cpp
    map/CMapVRT.cpp
    map/CMapWMTS.cpp
    map/IMap.cpp
    map/IMapOnline.cpp
    map/IMapProp.cpp
    map/cache/CDiskCache.cpp
    map/garmin/CGarminPoint.cpp
    map/garmin/CGarminPolygon.cpp
    map/garmin/CGarminStrTbl6.cpp
    map/garmin/CGarminStrTbl8.cpp
    map/garmin/CGarminStrTblUtf8.cpp
    map/garmin/CGarminTyp.cpp
    map/garmin/IGarminStrTbl.cpp
    map/mapsforge/types.cpp
    misc.h
    mouse/CMouseAdapter.cpp
    mouse/CMouseDummy.cpp
    mouse/CMouseEditArea.cpp
    mouse/CMouseEditRte.cpp
    mouse/CMouseEditTrk.cpp
    mouse/CMouseMoveWpt.cpp
    mouse/CMouseNormal.cpp
    mouse/CMousePrint.cpp
    mouse/CMouseRadiusWpt.cpp
    mouse/CMouseRangeTrk.cpp
    mouse/CMouseRuler.cpp
    mouse/CMouseSelect.cpp
    mouse/CMouseWptBubble.cpp
    mouse/CScrOptPrint.cpp
    mouse/range/CActionSelect.cpp
    mouse/range/CRangeToolSetup.cpp
    mouse/range/CScrOptRangeTool.cpp
    mouse/range/CScrOptRangeTrk.cpp
    mouse/CScrOptRuler.cpp
    mouse/CScrOptSelect.cpp
    mouse/CScrOptSemaphoreLocker.cpp
    mouse/CScrOptUnclutter.cpp
    mouse/IMouse.cpp
    mouse/IMouseSelect.cpp
    mouse/IScrOpt.cpp
    mouse/line/CLineOpAddPoint.cpp
    mouse/line/CLineOpDeletePoint.cpp
    mouse/line/CLineOpMovePoint.cpp
    mouse/line/CLineOpSelectRange.cpp
    mouse/line/CScrOptEditLine.cpp
    mouse/line/CScrOptRangeLine.cpp
    mouse/line/ILineOp.cpp
    mouse/line/IMouseEditLine.cpp
    plot/CPlot.cpp
    plot/CPlotAxis.cpp
    plot/CPlotAxisTime.cpp
    plot/CPlotData.cpp
    plot/CPlotProfile.cpp
    plot/CPlotTrack.cpp
    plot/IPlot.cpp
    plot/ITrack.cpp
    poi/CPoiCategory.cpp
    poi/CPoiDraw.cpp
    poi/CPoiFileItem.cpp
    poi/CPoiFilePOI.cpp
    poi/CPoiFilePOI_TagMap.cpp
    poi/CPoiIconCategory.cpp
    poi/CPoiItemPOI.cpp
    poi/CPoiList.cpp
    poi/CPoiPathSetup.cpp
    poi/CPoiPropSetup.cpp
    poi/IPoiFile.cpp
    poi/IPoiProp.cpp
    print/CPrintDialog.cpp
    print/CScreenshotDialog.cpp
    qlgt/CQlb.cpp
    qlgt/CQlgtDb.cpp
    qlgt/CQlgtDiary.cpp
    qlgt/CQlgtFolder.cpp
    qlgt/CQlgtRoute.cpp
    qlgt/CQlgtTrack.cpp
    qlgt/CQlgtWpt.cpp
    qlgt/CQmsDb.cpp
    qlgt/IItem.cpp
    qlgt/IQlgtOverlay.cpp
    qlgt/converter.cpp
    realtime/CRtDraw.cpp
    realtime/CRtSelectSource.cpp
    realtime/CRtWorkspace.cpp
    realtime/IRtInfo.cpp
    realtime/IRtRecord.cpp
    realtime/IRtSource.cpp
    realtime/gpstether/CRtGpsTether.cpp
    realtime/gpstether/CRtGpsTetherInfo.cpp
    realtime/gpstether/CRtGpsTetherRecord.cpp
    realtime/ais/CRtAis.cpp
    realtime/ais/CRtAisInfo.cpp
    realtime/ais/CRtAisRecord.cpp
    realtime/opensky/CRtOpenSky.cpp
    realtime/opensky/CRtOpenSkyInfo.cpp
    realtime/opensky/CRtOpenSkyRecord.cpp
    setup/CAppSetupLinux.cpp
    setup/CAppSetupMac.cpp
    setup/CAppSetupWin.cpp
    setup/CCommandProcessor.cpp
    setup/CLogHandler.cpp
    setup/IAppSetup.cpp
    tool/CImportDatabase.cpp
    tool/CMapVrtBuilder.cpp
    tool/CRoutinoDatabaseBuilder.cpp
    tool/IToolShell.cpp
    units/CCoordFormatSetup.cpp
    units/CTimeZoneSetup.cpp
    units/CUnitImperial.cpp
    units/CUnitMetric.cpp
    units/CUnitNautic.cpp
    units/CUnitAviation.cpp
    units/CUnitsSetup.cpp
    units/IUnit.cpp
    widgets/CColorLegend.cpp
    widgets/CDateTimeEditor.cpp
    widgets/CDoubleSpinBox.cpp
    widgets/CFadingIcon.cpp
    widgets/CHistoryListWidget.cpp
    widgets/CLineEdit.cpp
    widgets/CPhotoAlbum.cpp
    widgets/CSelectDoubleListWidget.cpp
    widgets/CScaleLabel.cpp
    widgets/CTemplateWidget.cpp
    widgets/CTextEdit.cpp
    widgets/CTextEditWidget.cpp
    widgets/CTextEditWidgetSelMenu.cpp
    widgets/CTinySpinBox.cpp
    ../common/help/CHelp.cpp
    ../common/help/CHelpBrowser.cpp
    ../common/help/CHelpIndex.cpp
    ../common/help/CHelpSearch.cpp
    ../common/gis/GeoMath.cpp
    ../common/gis/proj_x.cpp
)


if(Qt6DBus_FOUND)
set( SRCS
    ${SRCS}
    device/IDeviceAccess.cpp
    device/CDeviceWatcherLinux.cpp
    device/CDeviceAccessKMtp.cpp
    device/CDeviceAccessGvfsMtp.cpp
    device/CDeviceGarminMtp.cpp
    device/CDeviceGarminArchiveMtp.cpp
    device/CDeviceGenericMtp.cpp
    device/dbus/org.kde.kmtp.Daemon.cpp
    device/dbus/org.kde.kmtp.Device.cpp
    device/dbus/org.kde.kmtp.Storage.cpp
    device/dbus/org.gtk.vfs.MTPVolumeMonitor.cpp
    device/dbus/org.gtk.vfs.MountTracker.cpp
    device/dbus/org.gtk.vfs.Mount.cpp
    device/dbus/metatypes.cpp
)
endif(Qt6DBus_FOUND)


if (APPLE)
set( SRCS
    ${SRCS}
    device/CDeviceWatcherMac.cpp
)
endif(APPLE)

if(WIN32)
set( SRCS
    ${SRCS}
    device/CDeviceWatcherWindows.cpp
)
endif(WIN32)


set( HDRS
    CAbout.h
    CMainWindow.h
    CSingleInstanceProxy.h
    contributors.h
    canvas/CCanvas.h
    canvas/CCanvasSetup.h
    canvas/CCanvasSelect.h
    canvas/IDrawContext.h
    canvas/IDrawObject.h
    dem/CDemDraw.h
    dem/CDemItem.h
    dem/CDemList.h
    dem/CDemPathSetup.h
    dem/CDemPropSetup.h
    dem/CDemVRT.h
    dem/CDemWCS.h
    dem/IDem.h
    dem/IDemProp.h
    device/CDeviceGarmin.h
    device/CDeviceGarminArchive.h
    device/CDeviceTwoNav.h
    device/IDevice.h
    device/IDeviceWatcher.h
    gis/CGisDatabase.h
    gis/CGisDraw.h
    gis/CGisItemRate.h
    gis/CGisListDB.h
    gis/CGisListWks.h
    gis/CGisWorkspace.h
    gis/CSelDevices.h
    gis/IGisItem.h
    gis/IGisLine.h

=== src/qmaptool/CMakeLists.txt ===
# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)
# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

###############################################################################################
# Setup application name
###############################################################################################

set(APPLICATION_NAME qmaptool)

###############################################################################################
# All source files needed to compile
###############################################################################################
set( SRCS
    CAbout.cpp
    canvas/CCanvas.cpp
    canvas/CDrawContextPixel.cpp
    canvas/CDrawContextProj.cpp
    canvas/IDrawContext.cpp
    CMainWindow.cpp
    CSingleInstanceProxy.cpp
    helpers/CDraw.cpp
    helpers/CGdalFile.cpp
    helpers/mitab.cpp
    items/CItemCutMap.cpp
    items/CItemFile.cpp
    items/CItemListWidget.cpp
    items/CItemMap.cpp
    items/CItemMapLayer.cpp
    items/CItemRefMap.cpp
    items/CItemTreeWidget.cpp
    items/IItem.cpp
    main.cpp
    overlay/COverlayCutMap.cpp
    overlay/COverlayGridTool.cpp
    overlay/COverlayRefMap.cpp
    overlay/gridtool/CGridPlacer.cpp
    overlay/gridtool/CGridPoint.cpp
    overlay/gridtool/CGridSelArea.cpp
    overlay/gridtool/CGridSetRef.cpp
    overlay/IOverlay.cpp
    overlay/refmap/CDialogRefPoint.cpp
    overlay/refmap/COverlayRefMapPoint.cpp
    overlay/refmap/CProjWizard.cpp
    setup/CAppSetupLinux.cpp
    setup/CAppSetupMac.cpp
    setup/CAppSetupWin.cpp
    setup/CCommandProcessor.cpp
    setup/CLogHandler.cpp
    setup/CSetupExtTools.cpp
    setup/IAppSetup.cpp
    shell/CShellCmd.cpp
    shell/CShell.cpp
    tool/export/CToolExportJnx.cpp
    tool/CToolAddOverview.cpp
    tool/CToolBox.cpp
    tool/CToolCutMap.cpp
    tool/CToolExport.cpp
    tool/CToolGDALGroupBox.cpp
    tool/CToolGrid.cpp
    tool/CToolOverviewGroupBox.cpp
    tool/CToolPalettize.cpp
    tool/CToolRefMap.cpp
    tool/CToolStack.cpp
    tool/ITool.cpp
    tool/IToolGui.cpp
    units/CCoordFormatSetup.cpp
    units/CTimeZoneSetup.cpp
    units/CUnitImperial.cpp
    units/CUnitMetric.cpp
    units/CUnitNautic.cpp
    units/CUnitsSetup.cpp
    units/IUnit.cpp
    ../common/help/CHelp.cpp
    ../common/help/CHelpBrowser.cpp
    ../common/help/CHelpIndex.cpp
    ../common/help/CHelpSearch.cpp
    ../common/gis/GeoMath.cpp
    ../common/gis/proj_x.cpp
)

set( HDRS
    CAbout.h
    canvas/CCanvas.h
    canvas/CDrawContextPixel.h
    canvas/CDrawContextProj.h
    canvas/IDrawContext.h
    CMainWindow.h
    CSingleInstanceProxy.h
    helpers/CDraw.h
    helpers/CGdalFile.h
    helpers/CSettings.h
    helpers/CSettings.h
    helpers/mitab.h
    items/CItemCutMap.h
    items/CItemFile.h
    items/CItemListWidget.h
    items/CItemMap.h
    items/CItemMapLayer.h
    items/CItemRefMap.h
    items/CItemTreeWidget.h
    items/IItem.h
    overlay/COverlayCutMap.h
    overlay/COverlayGridTool.h
    overlay/COverlayRefMap.h
    overlay/gridtool/CGridPlacer.h
    overlay/gridtool/CGridPoint.h
    overlay/gridtool/CGridSelArea.h
    overlay/gridtool/CGridSetRef.h
    overlay/IOverlay.h
    overlay/refmap/CDialogRefPoint.h
    overlay/refmap/COverlayRefMapPoint.h
    overlay/refmap/CProjWizard.h
    setup/CAppOpts.h
    setup/CAppSetupLinux.h
    setup/CAppSetupMac.h
    setup/CAppSetupWin.h
    setup/CCommandProcessor.h
    setup/CLogHandler.h
    setup/CSetupExtTools.h
    setup/IAppSetup.h
    shell/CShellCmd.h
    shell/CShell.h
    tool/export/CToolExportJnx.h
    tool/CToolAddOverview.h
    tool/CToolBox.h
    tool/CToolCutMap.h
    tool/CToolExport.h
    tool/CToolGDALGroupBox.h
    tool/CToolGrid.h
    tool/CToolOverviewGroupBox.h
    tool/CToolPalettize.h
    tool/CToolRefMap.h
    tool/CToolStack.h
    tool/IToolGui.h
    tool/ITool.h
    units/CCoordFormatSetup.h
    units/CTimeZoneSetup.h
    units/CUnitImperial.h
    units/CUnitMetric.h
    units/CUnitNautic.h
    units/CUnitsSetup.h
    units/IUnit.h
    version.h
    ../common/help/CHelp.h
    ../common/help/CHelpBrowser.h
    ../common/help/CHelpIndex.h
    ../common/help/CHelpSearch.h
    ../common/gis/GeoMath.h
    ../common/gis/proj_x.h
)

set( UIS
    IAbout.ui
    IMainWindow.ui
    items/IItemListWidget.ui
    items/IItemTreeWidget.ui
    overlay/gridtool/IGridPlacer.ui
    overlay/gridtool/IGridSelArea.ui
    overlay/gridtool/IGridSetRef.ui
    overlay/IOverlayCutMap.ui
    overlay/IOverlayGridTool.ui
    overlay/IOverlayRefMap.ui
    overlay/refmap/IDialogRefPoint.ui
    overlay/refmap/IProjWizard.ui
    setup/ISetupExtTools.ui
    tool/export/IToolExportJnx.ui
    tool/IToolAddOverview.ui
    tool/IToolCutMap.ui
    tool/IToolExport.ui
    tool/IToolGDALGroupBox.ui
    tool/IToolGrid.ui
    tool/IToolOverviewGroupBox.ui
    tool/IToolPalettize.ui
    tool/IToolRefMap.ui
    units/ICoordFormatSetup.ui
    units/ITimeZoneSetup.ui
    units/IUnitsSetup.ui
)

set( RCS
    resources.qrc
)


###############################################################################################
# Some Qt magic
###############################################################################################

qt6_wrap_ui(UI_HDRS ${UIS})
qt6_add_resources(RC_SRCS ${RCS})


###############################################################################################
# Build source file and include paths lists
###############################################################################################
set(MAININP
    ${SRCS}
    ${HDRS}
    ${UI_HDRS}
    ${RC_SRCS}
    ${${APPLICATION_NAME}_DESKTOP_FILES}
)

include_directories(
    .
    ../common
    SYSTEM # this prevents warnings from non-QMS headers
    ${CMAKE_BINARY_DIR}
    ${GDAL_INCLUDE_DIRS}
    ${PROJ_INCLUDE_DIRS}
)

if(APPLE)
     INCLUDE_DIRECTORIES(/System/Library/Frameworks/Foundation.framework)
     INCLUDE_DIRECTORIES(/System/Library/Frameworks/DiskArbitration.framework)
endif(APPLE)


###############################################################################################
# Build the executable and define necessary libraries.
###############################################################################################
if(WIN32)
    set (ICON win32icon.rc)
endif()
add_executable(${APPLICATION_NAME} WIN32 ${MAININP} ${ICON})

###############################################################################################
# Translation related stuff
###############################################################################################
if(${UPDATE_TRANSLATIONS_PURGE_OBSOLETE})
    set(UPDATE_OPTIONS -noobsolete)
else()
    set(UPDATE_OPTIONS )
endif()
set( TRANSLATIONS
    locale/${APPLICATION_NAME}.ts
    locale/${APPLICATION_NAME}_de.ts
    locale/${APPLICATION_NAME}_es.ts
    locale/${APPLICATION_NAME}_it.ts
    locale/${APPLICATION_NAME}_ru.ts
)

if(${UPDATE_TRANSLATIONS})
    qt_add_translations(${APPLICATION_NAME}
        TS_FILES ${TRANSLATIONS}
        QM_FILES_OUTPUT_VARIABLE ${APPLICATION_NAME}_QM_FILES
        LUPDATE_TARGET ${APPLICATION_NAME}_lupdate
        SOURCE_TARGETS ${APPLICATION_NAME}
        LUPDATE_OPTIONS ${UPDATE_OPTIONS}
    )
    add_dependencies(${APPLICATION_NAME} ${APPLICATION_NAME}_lupdate)
else(${UPDATE_TRANSLATIONS})
    qt_add_lrelease(
        TS_FILES  ${TRANSLATIONS}
        QM_FILES_OUTPUT_VARIABLE ${APPLICATION_NAME}_QM_FILES
    )
    qt_add_resources(${APPLICATION_NAME} "translations"
        PREFIX "/locale"
        BASE "${CMAKE_CURRENT_BINARY_DIR}"
        FILES "${${APPLICATION_NAME}_QM_FILES}"
    )
endif(${UPDATE_TRANSLATIONS})


target_compile_definitions(${APPLICATION_NAME} PUBLIC
    -DVER_MAJOR=${PROJECT_VERSION_MAJOR}
    -DVER_MINOR=${PROJECT_VERSION_MINOR}
    -DVER_STEP=${PROJECT_VERSION_PATCH}
    -DVER_TWEAK=${VERSION_SUFFIX}
    -DAPPLICATION_NAME=${APPLICATION_NAME}
)

target_link_libraries(${APPLICATION_NAME}
    Qt6::Widgets
    Qt6::Network
    Qt6::Help
    ${GDAL_LIBRARIES}
    ${PROJ_LIBRARIES}
)

if(APPLE)
     target_link_libraries(${APPLICATION_NAME}
     ${Foundation_LIBRARY}
     ${DiskArbitration_LIBRARY}
    )
endif(APPLE)


###############################################################################################
# Install target related stuff
###############################################################################################
install(TARGETS     ${APPLICATION_NAME}                     DESTINATION     ${BIN_INSTALL_DIR})

if (UNIX AND NOT WIN32 AND NOT APPLE)
    install(FILES   ${${APPLICATION_NAME}_QM_FILES}         DESTINATION     ${DATA_INSTALL_PREFIX}/${APPLICATION_NAME}/translations)
    install(FILES   ${${APPLICATION_NAME}_DESKTOP_FILES}    DESTINATION     ${XDG_APPS_DIR})
endif (UNIX AND NOT WIN32 AND NOT APPLE)
if(WIN32)
    qt_generate_deploy_app_script(
        TARGET ${APPLICATION_NAME}
        OUTPUT_SCRIPT deploy_script_${APPLICATION_NAME}
        NO_UNSUPPORTED_PLATFORM_ERROR
    )
    install(SCRIPT ${deploy_script_${APPLICATION_NAME}})
endif()

=== src/qmt_rgb2pct/CMakeLists.txt ===
# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)
# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

###############################################################################################
# Setup application name
###############################################################################################

set(APPLICATION_NAME qmt_rgb2pct)

###############################################################################################
# All source files needed to compile
###############################################################################################
set( SRCS
    main.cpp
    CApp.cpp
)

set( HDRS
    version.h
    CApp.h
)

set( UIS
)

set( RCS
)


###############################################################################################
# Some Qt magic
###############################################################################################

qt6_wrap_ui(UI_HDRS ${UIS})
qt6_add_resources(RC_SRCS ${RCS})


###############################################################################################
# Build source file and include paths lists
###############################################################################################
set(MAININP
    ${SRCS}
    ${HDRS}
    ${UI_HDRS}
    ${RC_SRCS}
    ${${APPLICATION_NAME}_QM_FILES}
    ${${APPLICATION_NAME}_DESKTOP_FILES}
)

include_directories(
    SYSTEM # this prevents warnings from non-QMS headers
    ${CMAKE_BINARY_DIR}
    ${GDAL_INCLUDE_DIRS}
    ${PROJ_INCLUDE_DIRS}
)

if(APPLE)
     INCLUDE_DIRECTORIES(/System/Library/Frameworks/Foundation.framework)
     INCLUDE_DIRECTORIES(/System/Library/Frameworks/DiskArbitration.framework)
endif(APPLE)


###############################################################################################
# Build the executable and define necessary libraries.
###############################################################################################
add_executable(${APPLICATION_NAME} WIN32 ${MAININP})

if(${UPDATE_TRANSLATIONS_PURGE_OBSOLETE})
    set(UPDATE_OPTIONS -noobsolete)
else()
    set(UPDATE_OPTIONS )
endif()
set( TRANSLATIONS
    locale/${APPLICATION_NAME}.ts
    locale/${APPLICATION_NAME}_de.ts
)

if(${UPDATE_TRANSLATIONS})
    qt_add_translations(${APPLICATION_NAME}
        TS_FILES ${TRANSLATIONS}
        QM_FILES_OUTPUT_VARIABLE ${APPLICATION_NAME}_QM_FILES
        LUPDATE_TARGET ${APPLICATION_NAME}_lupdate
        SOURCE_TARGETS ${APPLICATION_NAME}
        LUPDATE_OPTIONS ${UPDATE_OPTIONS}
    )
    add_dependencies(${APPLICATION_NAME} ${APPLICATION_NAME}_lupdate)
else(${UPDATE_TRANSLATIONS})
    qt_add_lrelease(
        TS_FILES  ${TRANSLATIONS}
        QM_FILES_OUTPUT_VARIABLE ${APPLICATION_NAME}_QM_FILES
    )
    qt_add_resources(${APPLICATION_NAME} "translations"
        PREFIX "/locale"
        BASE "${CMAKE_CURRENT_BINARY_DIR}"
        FILES "${${APPLICATION_NAME}_QM_FILES}"
    )
endif(${UPDATE_TRANSLATIONS})


target_compile_definitions(${APPLICATION_NAME} PUBLIC
    -DVER_MAJOR=${PROJECT_VERSION_MAJOR}
    -DVER_MINOR=${PROJECT_VERSION_MINOR}
    -DVER_STEP=${PROJECT_VERSION_PATCH}
    -DVER_TWEAK=${VERSION_SUFFIX}
    -DAPPLICATION_NAME=${APPLICATION_NAME}
)

target_link_libraries(${APPLICATION_NAME}
    Qt6::Core
    ${GDAL_LIBRARIES}
    ${PROJ_LIBRARIES}
)

if(APPLE)
     target_link_libraries(${APPLICATION_NAME}
     ${Foundation_LIBRARY}
     ${DiskArbitration_LIBRARY}
    )
endif(APPLE)


###############################################################################################
# Install target related stuff
###############################################################################################
install(TARGETS     ${APPLICATION_NAME}                     DESTINATION     ${BIN_INSTALL_DIR})

if (UNIX AND NOT WIN32 AND NOT APPLE)
    install(FILES   ${${APPLICATION_NAME}_QM_FILES}         DESTINATION     ${DATA_INSTALL_PREFIX}/${APPLICATION_NAME}/translations)
    install(FILES   ${${APPLICATION_NAME}_DESKTOP_FILES}    DESTINATION     ${XDG_APPS_DIR})
endif (UNIX AND NOT WIN32 AND NOT APPLE)
if(WIN32)
    qt_generate_deploy_app_script(
        TARGET ${APPLICATION_NAME}
        OUTPUT_SCRIPT deploy_script_${APPLICATION_NAME}
        NO_UNSUPPORTED_PLATFORM_ERROR
    )
    install(SCRIPT ${deploy_script_${APPLICATION_NAME}})
endif()

=== test/unittest/CMakeLists.txt ===
# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)
# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

find_package(Qt5Test)

find_package(Qt5Widgets)
find_package(Qt5Core)
find_package(Qt5Xml)
find_package(Qt5Script)
find_package(Qt5Sql)
find_package(Qt5WebKitWidgets)
find_package(Qt5LinguistTools)
find_package(Qt5PrintSupport)
if(UNIX)
    if(Qt5DBus_FOUND)
        find_package(Qt5DBus)
    endif(Qt5DBus_FOUND)
endif(UNIX)
find_package(GDAL REQUIRED)
find_package(PROJ REQUIRED)
find_package(ROUTINO REQUIRED)

if(UNIX)
    if(Qt5DBus_FOUND)
        set(DBUS_LIB Qt6::DBus)
    endif(Qt5DBus_FOUND)
else(UNIX)
    set(DBUS_LIB)
endif(UNIX)

if(UNIX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
endif(UNIX)


include_directories(
    ${CMAKE_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/../../src
)

include_directories(
    SYSTEM # this prevents warnings from non-QMS headers
    ${GDAL_INCLUDE_DIRS}
    ${PROJ_INCLUDE_DIRS}
    ${ROUTINO_INCLUDE_DIRS}
    ${ALGLIB_INCLUDE_DIRS}
)

qt5_add_resources(RC_SRCS ./../../src/resources.qrc)

add_executable(qttest EXCLUDE_FROM_ALL
    main.cpp
    test_QMapShack.h
    CGpxProject.cpp
    CFitProject.cpp
    CQmsProject.cpp
    CSlfReader.cpp
    CKnownExtension.cpp
    TestHelper.cpp
    CGisItemTrk.cpp
    ${RC_SRCS})

# copy the input files required by the unittests to ./bin/input
file(COPY input DESTINATION ${CMAKE_BINARY_DIR}/bin/)

target_link_libraries(qttest
    Qt6::Widgets
    Qt6::Xml
    Qt6::Script
    Qt6::Sql
    Qt6::WebKitWidgets
    Qt6::PrintSupport
    Qt6::Test
    QMS
    ${DBUS_LIB}
    ${GDAL_LIBRARIES}
    ${PROJ_LIBRARIES}
    ${ROUTINO_LIBRARIES}
    ${ALGLIB_LIBRARIES}
)

add_custom_command(
    OUTPUT tests_run.log
    COMMAND qttest
    DEPENDS qttest
    COMMENT "Executing the Unittests"
    VERBATIM
)

add_custom_target(
    run_tests
    DEPENDS tests_run.log
)

=== MacOSX/helpers/otoolrecursive/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(otoolrecursive LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

add_executable(otoolrecursive main.cpp
  loaderpathresolver.h loaderpathresolver.cpp)

include(GNUInstallDirs)
install(TARGETS otoolrecursive
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

=== debian/changelog ===
qmapshack (1.18.1-1) unstable; urgency=medium

  * New upstream release.
  * Update lintian overrides.
  * Drop Rules-Requires-Root: no, default since dpkg 1.22.13.
  * Update copyright file.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 16 Oct 2025 12:54:56 +0200

=== debian/control ===
Source: qmapshack
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Jaromír Mikeš <mira.mikes@seznam.cz>,
           Bas Couwenberg <sebastic@debian.org>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               libalglib-dev,
               libgdal-dev (>= 1.10.1-0~),
               libproj-dev,
               libroutino-dev (>= 3.1),
               libquazip1-qt6-dev,
               pkgconf,
               qt6-base-dev,
               qt6-declarative-dev,
               qt6-tools-dev,
               qt6-webengine-dev
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debian-gis-team/qmapshack
Vcs-Git: https://salsa.debian.org/debian-gis-team/qmapshack.git
Homepage: https://github.com/Maproom/qmapshack/wiki

Package: qmapshack
Architecture: any
Depends: libqt6sql6-sqlite,
         ${shlibs:Depends},
         ${misc:Depends}
Recommends: gdal-bin,
            routino
Suggests: gpsd
Description: GPS mapping (GeoTiff and vector) and GPSr management
 This package provides a versatile tool for GPS maps in GeoTiff format as
 well as Garmin's img vector map format.
 You can also view and edit your GPX tracks.
 QMapShack is the successor of QLandkarteGT.
 .
 Main features:
  - Use of several workspaces.
  - Use several maps on a workspace.
  - Handle data project-oriented.

=== debian/rules ===
#!/usr/bin/make -f

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

export QT_SELECT := qt5

# one ring to rule them all ...
%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_VERBOSE_MAKEFILE=ON \
		-DUPDATE_TRANSLATIONS=OFF

override_dh_installchangelogs:
	dh_installchangelogs changelog.txt

override_dh_compress:
	dh_compress -X.qch -X.qhc
